from appium.webdriver.common.appiumby import AppiumBy
from 预定系统.Base.app_base import *
import logging
from time import sleep

# 配置日志记录
logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')

class Exhibition_hall_inspection_000x:
    """
        执行指令：
            1.cd 预定系统
            2.hytest --report_title 会议预约测试报告 --report_url_prefix http://192.168.1.225 --test 展厅巡检_0**
    """
    tags = ['展厅巡检_腾讯会议']

    def teststeps(self):
        app_drive = None
        try:
            # 腾讯："com.tencent.wemeet.app"   ".StartupActivity"
            app_drive = app_setup_driver("Android", "7.1.2", "127.0.0.1:62001", "com.tencent.wemeet.app",
                                         ".StartupActivity")
            app_drive.implicitly_wait(20)  # 设置缺省等待时间

            # 使用显式等待来等待元素出现
            logging.info("等待登录页加载...")

            # 定位第一场会议按钮元素，并点击按钮
            logging.info("尝试定位【会议名称】按钮元素，并点击按钮")
            # meeting_button = app_drive.find_element(AppiumBy.XPATH,"/hierarchy/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.LinearLayout/androidx.viewpager.widget.ViewPager/android.view.ViewGroup/android.widget.LinearLayout[1]/android.view.ViewGroup/android.widget.RelativeLayout/androidx.recyclerview.widget.RecyclerView/android.view.ViewGroup[4]/android.view.ViewGroup/androidx.appcompat.widget.LinearLayoutCompat[1]/android.view.ViewGroup/android.widget.TextView")
            meeting_button = app_drive.find_element(AppiumBy.XPATH,"/hierarchy/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.LinearLayout/androidx.viewpager.widget.ViewPager/android.view.ViewGroup/android.widget.LinearLayout[1]/android.view.ViewGroup/android.widget.RelativeLayout/androidx.recyclerview.widget.RecyclerView/android.view.ViewGroup[1]/android.view.ViewGroup/androidx.appcompat.widget.LinearLayoutCompat/android.view.ViewGroup/android.widget.TextView")
            logging.info("定位会议成功")
            # 点击【加入会议】按钮
            meeting_button.click()
            logging.info("点击【会议】按钮成功")
            sleep(2)

            # 点击【加入会议】按钮
            logging.info("尝试定位【加入会议】按钮元素，并点击按钮")
            join_meeting_button = app_drive.find_element(AppiumBy.XPATH,
                                                         "/hierarchy/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.view.ViewGroup/androidx.appcompat.widget.LinearLayoutCompat/androidx.appcompat.widget.LinearLayoutCompat/android.widget.TextView")
            logging.info("定位【加入会议】按钮成功")
            join_meeting_button.click()
            logging.info("点击【加入会议】按钮成功")
            sleep(8)
            app_drive.get_screenshot_as_file(
                r"D:\GithubData\自动化\ubains-module-test\预定系统\reports\imgs\Exhibit_Inspect\Tx_meeting\会场画面截屏.png")
            sleep(8)

        except Exception as e:
            logging.error(f"发生错误: {e}", exc_info=True)

        finally:
            if app_drive:
                app_drive.quit()
                logging.info("驱动程序已退出。")


# from appium.webdriver.common.appiumby import AppiumBy
# from 预定系统.Base.app_base import *
# import logging
# from time import sleep
# import unittest
# import os
# from HtmlTestRunner import HTMLTestRunner
#
# # 配置日志记录
# logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')
#
# class TestAppTXCent(unittest.TestCase):
#     def setUp(self):
#         self.app_drive = None
#         try:
#             # 腾讯："com.tencent.wemeet.app"   ".StartupActivity"
#             self.app_drive = app_setup_driver("Android", "7.1.2", "127.0.0.1:62001", "com.tencent.wemeet.app", ".StartupActivity")
#             self.app_drive.implicitly_wait(20)  # 设置缺省等待时间
#         except Exception as e:
#             logging.error(f"初始化驱动程序时发生错误: {e}", exc_info=True)
#             self.fail(f"初始化驱动程序时发生错误: {e}")
#
#     def tearDown(self):
#         if self.app_drive:
#             input('**** 按任意键退出..')
#             self.app_drive.quit()
#             logging.info("驱动程序已退出。")
#
#     def test_app_txcent(self):
#         try:
#             # 使用显式等待来等待元素出现
#             logging.info("等待登录页加载...")
#
#             # 定位第一场会议按钮元素，并点击按钮
#             logging.info("尝试定位【会议名称】按钮元素，并点击按钮")
#             meeting_button = self.app_drive.find_element(AppiumBy.XPATH, "/hierarchy/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.FrameLayout/android.widget.LinearLayout/androidx.viewpager.widget.ViewPager/android.view.ViewGroup/android.widget.LinearLayout[1]/android.view.ViewGroup/android.widget.RelativeLayout/androidx.recyclerview.widget.RecyclerView/android.view.ViewGroup[4]/android.view.ViewGroup/androidx.appcompat.widget.LinearLayoutCompat[1]/android.view.ViewGroup/android.widget.TextView")
#             logging.info("定位会议成功")
#             # 点击【加入会议】按钮
#             meeting_button.click()
#             logging.info("点击【会议】按钮成功")
#             sleep(2)
#
#             # 点击【加入会议】按钮
#             logging.info("尝试定位【加入会议】按钮元素，并点击按钮")
#             join_meeting_button = self.app_drive.find_element(AppiumBy.XPATH, "/hierarchy/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.widget.LinearLayout/android.widget.FrameLayout/android.view.ViewGroup/androidx.appcompat.widget.LinearLayoutCompat/androidx.appcompat.widget.LinearLayoutCompat/android.widget.TextView")
#             logging.info("定位【加入会议】按钮成功")
#             join_meeting_button.click()
#             logging.info("点击【加入会议】按钮成功")
#             sleep(8)
#
#             # 截图并保存
#             screenshot_path = os.path.join(os.getcwd(), "reports", "imgs", "Exhibit_Inspect", "Tx_meeting", "会场控制截屏.png")
#             os.makedirs(os.path.dirname(screenshot_path), exist_ok=True)
#             self.app_drive.get_screenshot_as_file(screenshot_path)
#             logging.info(f"截图已保存到: {screenshot_path}")
#         except Exception as e:
#             logging.error(f"发生错误: {e}", exc_info=True)
#             self.fail(f"测试过程中发生错误: {e}")
#
# if __name__ == '__main__':
#     # 创建测试套件
#     suite = unittest.TestSuite()
#     suite.addTest(TestAppTXCent('test_app_txcent'))
#
#     # 定义报告文件路径
#     report_path = os.path.join(os.getcwd(), "reports", "Exhibit_Inspect", "Tx_meeting", "test_report.html")
#     os.makedirs(os.path.dirname(report_path), exist_ok=True)
#
#     # 运行测试并生成报告
#     with open(report_path, 'wb') as f:
#         runner = HTMLTestRunner(stream=f, title='腾讯会议自动化测试报告', description='测试报告详情')
#         runner.run(suite)
